#!/usr/bin/python
import socket, sys, re, os

USERFILE = "leetwww/users.txt"
SESSIONDIR = "leetwww/sessions/"
DATADIR = "leetwww/data/"

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
s.bind(("", int(sys.argv[1]))) 
s.listen(1)

def leet_create(parameters):
	regex = re.compile("([A-Za-z][A-Za-z0-9]+) ((\"([^\"]*)\")|([-_A-Za-z0-9]+)) ([-_A-Za-z0-9]+).*")
	match = regex.match(parameters)

	if not match:
		return "400 SYNTAX ERROR FOR CREATE COMMAND\n"

	username = match.group(1)
	realname = match.group(2)
	password = match.group(6)

	file = open(USERFILE, "r")

	for line in file:
		if username == line.split(" ", 1)[0]:
			return "300 USER EXISTS\n"

	file.close()

	string = "%s %s %s\n" % (username, realname, password)

	file = open(USERFILE, "a")
	file.write(string)

	os.mkdir(DATADIR+username)

	return "200 User Created!\n"

def leet_session(parameters):
	regex = re.compile("([A-Za-z0-9]+).*")
	match = regex.match(parameters)

	if not match:
		return "300 SYNTAX ERROR\n"

	session_id = match.group(1)
	
	files = os.listdir(SESSIONDIR)

	if session_id in files:
		return "400 SESSION ALREADY EXISTS\n"

	file = open(SESSIONDIR+session_id, "w")
	return "200 SESSION CREATED\n"

def get_full_name(username):
	file = open(USERFILE, "r")
	regex = re.compile("([A-Za-z][A-Za-z0-9]+) ((\"([^\"]*)\")|([-_A-Za-z0-9]+)) ([-_A-Za-z0-9]+)")
	
	for line in file:
		match = regex.match(line)
		file_username = match.group(1)

		if file_username == username:
			return match.group(2)

	return "unknown user"

def leet_dtp_upload(parameters, user, komm):
	komm.settimeout(4)

	if " " in parameters or "../" in parameters:
		return "300 INVALID PATH!\n"
	else:
		path  = DATADIR+user+"/"+parameters.strip()
		file  = open(path, "w")

	try:
		data = komm.recv(1024)
		match = re.match("Lines: ([\d]+)", data)

		if komm.recv(1024) != "\n":
			return "400 missing Newline after Lines"

		if not match:
			return "500 Lines not specified\n"
	except socket.timeout:
		return "500 Lines not specified\n"

	komm.send("200 Go ahead - (FUCK Forgot this before <_<)")

	try:
		for i in range(0, int(match.group(1))):
			file.write(komm.recv(1024))
	except socket.timeout:
		return "400 Not Enough lines\n"

	file.close()

	return "200 Thank you, %s, for uploading the file\n" % get_full_name(user)
	return "200 File uploaded via DTP\n"

def leet_dtp_download(parameters, user):
	path = parameters.strip()

	if parameters.recv(1024) != "\n":
		return "100 DTP-D SYNTAX ERROR\n"

	if " " in path or "../" in path:
		return "700 INVALID PATH"

	fullname = "foo"
	lines = "3"
	data = "foo\nbar\n;D"
	
	return "200 Thank you, %s, your file is %s long in encoded form. \n%s" % (fullname, lines, data)

def leet_dtp_mkdirs(parameters, user, komm):
	if "../" in parameters or " " in parameters:
		return "100 FUCK YOU!\n"

	for i in range(0,2):
		if komm.recv(1024) != "\n":
			return "100 SYNTAX ERROR"
	
	os.mkdir(DATADIR+user+"/"+parameters)
	return "200 Created DIR\n"

def get_auth(username, password):
	file = open(USERFILE, "r")
	regex = re.compile("([A-Za-z][A-Za-z0-9]+) ((\"([^\"]*)\")|([-_A-Za-z0-9]+)) ([-_A-Za-z0-9]+)")

	for line in file:
		match = regex.match(line)
		file_username = match.group(1)
		file_password = match.group(6)

		if file_username == username and file_password == password:
			file.close()
			return True

	file.close()
	return False

def leet_dtp(parameters, komm):
	cmd = parameters.split(" ", 4)

	if len(cmd) < 4:
		return "100 DTP SYNTAX ERROR\n"

	username = cmd[1]
	password = cmd[2]

	if not get_auth(username, password):
		return "120 LOGIN INCORRECT\n"

	if cmd[0] == "UPLOAD":
		return leet_dtp_upload(cmd[3].strip(), username, komm)
	elif cmd[0] == "DOWNLOAD":
		return leet_dtp_download(cmd[3].strip(), username, komm)
	elif cmd[0] == "MKDIRS":
		return leet_dtp_mkdirs(cmd[3].strip(), username, komm)
	else:
		return "100 SYNTAX ERROR\n"

try:
	while True:
		komm, addr = s.accept()
		data = komm.recv(1024)

		# Debug: Print Request
		print "IN:  " + data.strip()

		# Check for Proper Command
		if len(data.split(" ", 1)) == 2:
			cmd, parameters = data.split(" ", 1)
		else:
			cmd = "ERROR"
			output = "SYNTAX ERROR\n"

		if cmd == "CREATE":
			output = leet_create(parameters.strip())
		elif cmd == "SESSION":
			output = leet_session(parameters.strip())
		elif cmd == "DTP":
			output = leet_dtp(parameters.strip(), komm)
		else:
			output = "SYNTAX ERROR\n"

		print "OUT: " + output.strip()
		komm.send(output)
		komm.close()

finally:
	s.close()
