from os import curdir, sep
import re
import time
import BaseHTTPServer

parse_session_id = re.compile('^[A-Za-z0-9]+$')
parse_user = re.compile('^([A-Za-z][A-Za-z0-9]+)\s+("?.*"?)\s+([-_A-Za-z0-9]+)$')

parse_dtp = re.compile('^([A-Za-z][A-Za-z0-9]+)\s+([-_A-Za-z0-9]+)\s+(.*)$')

sessions = dict()
users = dict()

class TrivialHTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
    
    server_version = "TrivialHTTP/1.0"
    
    def parse_request(self):
        """Parse a request (internal).
        
        The request should be stored in self.raw_requestline; the results
        are in self.command, self.path, self.request_version and
        self.headers.
        
        Return True for success, False for failure; on failure, an
        error is sent back.
        
        """
        
        print '--------------------------------------------------'
        self.command = None  # set in case of error on the first line
        
        self.close_connection = 1
        
        requestline = self.raw_requestline
        print time.ctime(), '---- RAW:', self.raw_requestline.strip()
        
        if requestline[-2:] == '\r\n':
            requestline = requestline[:-2]
        elif requestline[-1:] == '\n':
            requestline = requestline[:-1]
        self.requestline = requestline
        
        """
        if requestline.startswith('SESSION'):
            words = requestline.split(None, 1)
        elif requestline.startswith('CREATE'):
            words = requestline.split(None, 1)
        else:
        """
        words = requestline.split(None, 1)
            
        self.commands = words
        if len(words) == 3:
            [command, path, version] = words
        elif len(words) == 2:
            [command, path] = words
        elif len(words) == 1:
            [command, path] = words[0], ''
        elif not words:
            return False
            
        print 'commands:', self.commands
        self.command, self.path, self.request_version = command, path, '1'
        
        return True
    
    def do_SESSION(self):
        
        session_id = self.commands[1]
        
        res = parse_session_id.match(session_id)
        if not res:
        
            self.send_response(300, 'TEMPORARY ERROR, TRY AGAIN LATER')
            self.send_header('Content-type', 'text/html')
            self.end_headers()
            return
            
        if sessions.has_key(session_id):
            self.send_response(400, 'SESSION ALREADY EXISTS')
            self.send_header('Content-type', 'text/html')
            self.end_headers()
            return
        
        sessions[session_id] = list()
        
        self.send_response(200, 'SESSION CREATED')
        self.send_header('Content-type', 'text/html')
        self.end_headers()
        return
        
    def do_CREATE(self):
        
        line = self.commands[1]
        
        res = parse_user.match(line)
        if not res:
            
            self.send_response(400, 'USER COULD NOT BE CREATED')
            self.send_header('Content-type', 'text/html')
            self.end_headers()
            return
            
        user = res.group(1)
        fullname = res.group(2)
        password = res.group(3)
        
        if users.has_key(user):
            if users[user][1] == password:
                self.send_response(300, 'USER EXISTS')
            else:
                self.send_response(300, 'USER EXISTS')
            self.end_headers()
            return

        users[user] = [fullname, password]

        self.send_response(200, 'USER CREATED')
        self.end_headers()
        return
        
    
    def do_DTP(self):
        
        line = self.commands[1].strip()
        
        res = parse_dtp.match(line)
        if not res:
            
            self.send_response(100, 'INVALID PARAMETERS')
            self.send_header('Content-type', 'text/html')
            self.end_headers()
            return
        
        user = res.group(1)
        password = res.group(2)
        path = res.group(3)
        
        if not users.has_key(user) or users[user][1] != password:
            
            self.send_response(120, 'LOGIN INCORRECT')
            self.send_header('Content-type', 'text/html')
            self.end_headers()
            return
        
        
        if line.startswith('UPLOAD'):
            pass
        elif line.startswith('DOWNLOAD'):
            pass
        elif line.startswith('MKDIRS'):
            if dirs.has_key(path):
                self.send_response(300, 'FAILURE')
                self.end_headers()
                return

            dirs[path] = True
            self.send_response(200, 'OK')
            self.end_headers()
            return
            
        if users.has_key(user):
            self.send_response(300, 'USER EXISTS')
            self.end_headers()
            return
        
        users[user] = list()
        
        self.send_response(200, 'USER CREATED')
        self.send_header('Content-type', 'text/html')
        self.end_headers()
        return

    def do_GET(self):
        self.send_response(200)
        self.send_header('Content-type',	'text/html')
        self.end_headers()
    
    def do_POST(self):
        pass

def main():
    try:
        server = BaseHTTPServer.HTTPServer(('', 8080), TrivialHTTPRequestHandler)
        print 'started httpserver...'
        server.serve_forever()
    except KeyboardInterrupt:
        server.socket.close()

if __name__ == '__main__':
    main()

