"""
 * LeetWWW - 25c3 CtF - 2008-12-30 
 * kriss | cato | !eof
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""


from twisted.application import service, internet
from twisted.internet.tcp import Server
from twisted.internet import reactor, protocol
from twisted.words.service import IRCUser 
from twisted.internet.protocol import Protocol
from twisted.web.http import HTTPChannel, Request

application=service.Application("leetwww")



import base64
import pickle
import re
import os


DB_FILE = "~/LeetWWW.db"
USER_DB_FILE = "~/LeetWWW_users.db"
SESSION_ID_PATTERN = re.compile('[A-Za-z0-9]+')

SESSION_CREATED = "created"
SESSION_EXISTS = "exist"

SESSION_CREATED = "200 SESSION CREATED"
SESSION_ERROR = "300 TEMPORARY ERROR, TRY AGAIN LATER"
SESSION_EXISTS = "400 SESSION ALREADY EXISTS"

USER_CREATED = "200 USER CREATED"
USER_EXISTS = "300 USER EXISTS"
USER_ERROR = "400 USER COULD NOT BE CREATED"



class DBHandler:
    def __init__(self):
        self.session_db_dict = {}
        self.user_db_dict = {}
        if os.path.exists(DB_FILE):
            print "Loading Session Data from file"  
            self.session_db_dict = pickle.load(DB_FILE) 
        if os.path.exists(USER_DB_FILE):
            print "Loading User Data from file"  
            self.user_db_dict = pickle.load(USER_DB_FILE) 
        	
        
    def _add_id(self, id):
        if not id in self.session_db_dict:
            self.session_db_dict[id] = id
            return True
        else:
            return False 
        self._save()

    def _save(self):
        pickle.dump(self.session_db_dict, DB_FILE)
        
        if not os.path.exists(DB_FILE):
            print "error saving to DB file"
            return False
        else:
            return True
        
    def session_exists(self, id):
        if id in self.session_db_dict:
            return True
        else:
            return False 
    
    def session_cmd(self, id):
        if not self.session_exists(id): 
            self._add_id(id)
            return SESSION_CREATED
        else:
            return SESSION_EXISTS
    
    def user_exists(self, login):
    	if login in self.user_db_dict:
    		return True
    	else:
    		return False
    
    def user_cmd(self, login, name, password):
    	if not self.user_exists(login):
    		self.user_db_dict[login] = (name, password)
    		return USER_CREATED
    	else:
    		return USER_EXISTS
    	
    def is_valid_user(self, login, password):
        return True
        print "login: %s, pass: %s" % (login, password)
        if self.user_exists(login) and self.user_db_dict[login][1] == password:
            print "matching pass: %s" % (self.user_db_dict[login][1])
            return True
        else:
            return False
     
db_handler = DBHandler()   

class wwwRequest(Request):
	def process(self):
		print self.method		
		self.setRawMode()
		#if self.method == "GET":
		
	def requestReceived(self, command, path, version):
		print command
		return Request.requestReceived(self, command, path, version)

COMMANDS = ["GET", "POST", "SESSION", "CREATE", "DTP"]
CMD_GET = "GET"
CMD_POST = "POST"
CMD_SESSION = "SESSION"
CMD_CREATE = "CREATE"
CMD_DTP = "DTP"

MAX_LINES = 1024

class LeetWWW(HTTPChannel):
    requestFactory = wwwRequest
    dtp_mode = ""
    dtp_step = 0
    upload_lines = 0
    dtp_file = None
    dtp_pass = None
    dtp_user = None
    data = ""
    	
    def cmd_get(self, text):
    	self.sendLine("300")
    	pass
    
    def cmd_post(self, text):
    	self.sendLine("300")
    	pass
    
    def cmd_session(self, text):
    	if len(text) < 2048:
    		id = text.split()[1]
    	else:
    		print "error: invalid (to long) session command"
    		return False	
    	ret_val = db_handler.session_cmd(id)
    	self.sendLine(ret_val)
    	return True
    
    def cmd_create(self, text):
    	if len(text) < 2048 and len(text.split()) > 2:
    		login = text.split()[0]
    		if len(text.split("\"")) > 1:
    			name = text.split("\"")[1]
    		else:
    			name = text.split()[1]
    		password = text.split()[-1]
    	else:
    		print "error: invalid (to long) session command"
    		return False	
    	ret_val = db_handler.user_cmd(login, name, password)
    	self.sendLine(ret_val)
    	return True
    
    def cmd_dtp(self, text):
    	self.dtp_step = 1
        if text.split() >= 4:
            self.dtp_mode = text.split()[1].upper().strip()
            self.dtp_user = text.split()[2].strip()
            self.dtp_pass = text.split()[3].strip()
            self.dtp_file = text.split()[4].strip()
            print "mode is", text.split()[1].upper().strip()
    
    	if len(text.split()) < 5:
    		self.sendLine("100 INVALID PARAMETERS")
    		return False
    	
    def dtp_save_data(self, data):
        if self.dtp_user and self.dtp_file and self.dtp_pass and \
                        db_handler.is_valid_user(self.dtp_user, self.dtp_pass):
            filename = os.path.realpath(os.path.join(os.path.expanduser("~"), self.dtp_file))
            print "saving to %s [%s]" % (filename, data)
            
        else:
            self.sendLine("120 LOGIN INCORRECT")
            print "login incorrect"
    
    
    def receiveUploadData(self, line):
        if len(line) <= 2:
            return
        
        cmd = line.split()[0]
        if self.dtp_step >= 1:
            self.dtp_step += 1
            if self.dtp_mode == "MKDIRS":
                if self.dtp_step >= 1:
                    self.dtp_step = 0
                    self.dtp_mode = ""
                    self.sendLine("300 FAILURE")
                
            if self.dtp_mode == "UPLOAD":
                print "in upload mode"
                if self.dtp_step >= 4:
                    print "receiving a line: [%s]" % line
                    if self.upload_lines < MAX_LINES:
                        print "decoding data"
                        self.data += base64.b64decode(line)
                    #if self.dtp_step >= 3 + self.upload_lines:
                        self.dtp_save_data(self.data)
                        self.dtp_step = 0
                        self.upload_lines = 0
                        self.dtp_mode = ""
                elif self.dtp_step >= 2:
                    print "in comand mode: (step: %s) [%s]" % (self.dtp_step, line)
                    if len(line.split()) >= 1 and line.split()[0] == "Lines:":                        
                        try:
                            self.upload_lines = int(line.split()[-1])
                            print "Accepting data with %s lines." % self.upload_lines 
                            self.sendLine("200 GO AHEAD")
                        except: 
                            print "ERROR receiving line count"
                            self.sendLine("500 LINES NOT SPECIFIED")
                            self.dtp_step = 0
                            self.dtp_mode = ""
#                    else:
#                        print "ERROR receiving line count"
#                        self.sendLine("500 LINES NOT SPECIFIED")
#                        self.dtp_step = 0
#                        self.dtp_mode = ""
                
            if self.dtp_mode == "DOWNLOAD":
                if self.dtp_step >= 1:
                    self.dtp_step = 0
                    self.dtp_mode = ""
                    self.sendLine("600 I DON'T FEEL LIKE COMPLYING RITE NOW, TRY AGAIN")
                                
            if self.dtp_step >= 3 + self.upload_lines:
                self.dtp_step = 0
                self.upload_lines = 0
                
    
    def dataReceived(self, line):
        #line = line.replace("HTTP20/0", "HTTP/1.0")    

        if len(line) <= 2:
            return
        
        cmd = line.split()[0]
    	self.resetTimeout()
    	print "Receiving data (step : %s): [%s]" % (self.dtp_step, line)
        if self.dtp_step >= 1:
            self.receiveUploadData(line)
        elif not cmd in COMMANDS:
            print "received strange command - ignoring"
            return        
    	else:
    		if cmd.upper() == CMD_GET:
    			self.cmd_get(line)
    		if cmd.upper() == CMD_POST:
    			self.cmd_post(line)
    		if cmd.upper() == CMD_SESSION:
    			self.cmd_session(line)
    		if cmd.upper() == CMD_CREATE:
    			self.cmd_create(line)
    		if cmd.upper() == CMD_DTP:
    			self.dtp_step = 1
    			self.cmd_dtp(line)
                for line in line.split("\n"):
                    self.receiveUploadData(line)
    	
    	"""		
    	print super(LeetWWW, self).__first_line
    	if super(LeetWWW, self).__first_line:
    		# if this connection is not persistent, drop any data which
    		# the client (illegally) sent after the last request.
    		if not self.persistent:
    			self.dataReceived = self.lineReceived = lambda *args: None
    			return
    
    		# IE sends an extraneous empty line (\r\n) after a POST request;
    		# eat up such a line, but only ONCE
    		if not line and self.__first_line == 1:
    			self.__first_line = 2
    			return
    
    		# create a new Request object
    		request = self.requestFactory(self, len(self.requests))
    		self.requests.append(request)
    
    		self.__first_line = 0
    		parts = line.split()
    	#	if len(parts) != 3:
    	#		self.transport.write("HTTP/1.1 400 Bad Request\r\n\r\n")
    	#		self.transport.loseConnection()
    	#		return
    		command, request, version = parts
    		self._command = command
    		self._path = request
    		self._version = version
        	elif line == '':
    		if self.__header:
    			self.headerReceived(self.__header)
    		self.__header = ''
    		self.allHeadersReceived()
    		if self.length == 0:
    			self.allContentReceived()
    		else:
    			self.setRawMode()
    	elif line[0] in ' \t':
    		self.__header = self.__header+'\n'+line
    	else:
    		if self.__header:
    			self.headerReceived(self.__header)
    		self.__header = line
    	"""

class WWWServerFactory(protocol.ServerFactory):
	protocol = LeetWWW

factory=WWWServerFactory()

serv=internet.TCPServer(8080, factory)
serv.setServiceParent(application)

